#include <gtk/gtk.h>
#include "im-protocol.h"
#include "matchbox-keyboard-remote.h"
#define ICON_FILE "/usr/share/pixmaps/matchbox-keyboard.png"

static void show_about(void) {
	gtk_show_about_dialog (NULL,
                       "program-name", "mb-systray",
                       "title", "About mb-systray",
                       "copyright", "© James Budiono 2015. GNU GPL Version 3 or later.",
                       "comments", "System-tray applet to show/hide matchbox keyboard.",
                       NULL);
}

static void leftclick(GtkStatusIcon *si, gpointer s) {
	protocol_send_event (MBKeyboardRemoteToggle);
}

static void rightclick(GtkStatusIcon *si, guint b,guint a_t, gpointer s) {
	GtkMenu* menu = (GtkMenu*) s;	
	gtk_menu_popup (GTK_MENU(menu), NULL, NULL, NULL, NULL, b, a_t);
}

static GtkItemFactoryEntry entries[] = {
  { "/_About",   NULL, show_about,          0, "<StockItem>", GTK_STOCK_ABOUT },
  { "/_Quit",    NULL, gtk_main_quit, 0, "<StockItem>", GTK_STOCK_QUIT } };

int main(int argc, char *argv[]){
	GtkStatusIcon *si;	
	GtkMenu *menu;
	
	gtk_init (&argc, &argv);	
	
	GtkItemFactory* factory = gtk_item_factory_new(GTK_TYPE_MENU, "<Root>", NULL);
	gtk_item_factory_create_items(factory, 2, entries, NULL);
	menu = GTK_MENU(gtk_item_factory_get_widget(factory, "<Root>")); 
	
	si = gtk_status_icon_new_from_file(ICON_FILE);
	gtk_status_icon_set_tooltip_markup(si, "Show keyboard.");
	g_signal_connect(G_OBJECT(si), "activate", G_CALLBACK(leftclick), NULL);
	g_signal_connect(G_OBJECT(si), "popup-menu", G_CALLBACK(rightclick), menu);
	
	gtk_main();
	return 0;
}
